# Save as maya/scripts/moom_utils.py

import maya.cmds as cmds
import os.path
import random

def read_textures(texturesDir='sourceimages'):
	projpath = cmds.workspace(q=True, rootDirectory=True)
	texpath = os.path.join(projpath, texturesDir)
	texnames = cmds.getFileList( folder=texpath, filespec='*.tx' )
	outnames = []
	for name in texnames:
		outnames.append( os.path.join(texturesDir, name) )
	return outnames
		
def add_string_attr(attrname, textures):
	attrname = 'mtoa_constant_' + attrname
	selections = cmds.ls(sl=True)
	for sel in selections:
		shapes = cmds.listRelatives(sel, s=True)
		# sel is a shape, therefore, does not have shape relatives
		if shapes == None:
			shapes = [sel]
		if len(shapes) == 0 or len(shapes[0]) == 0:
			print('Cannot find a shape to add attribute')
			return
		shape = shapes[0]
		if cmds.attributeQuery(attrname, node=shape, exists=True) == False:
			cmds.addAttr(shape, ln=attrname, sn=attrname, dt='string')
		texture = random.choice(textures)
		cmds.setAttr(shape + '.' + attrname, texture, type="string")
